#ifndef PLS_LIBRARY_H
#define PLS_LIBRARY_H

#include <utility>

#include "pls/algorithms/invoke.h"
#include "pls/algorithms/for_each.h"
#include "pls/internal/scheduling/scheduler.h"
#include "pls/internal/helpers/member_function.h"

namespace pls {

// 'basic' for-join APIs
using internal::scheduling::scheduler;
template<typename Function>
void spawn(Function &&function) {
  scheduler::spawn(std::forward<Function>(function));
}
void sync() {
  scheduler::sync();
}

// general helpers that can be handy when using PLS
template<class C, typename R, typename ...ARGS>
using member_function = internal::helpers::member_function<C, R, ARGS...>;

// parallel patterns API
using algorithm::invoke;
using algorithm::for_each;
using algorithm::for_each_range;
}

#endif
